<?php
	
	/*
	****************************************
	* Script de synchronisation programme *
	*       appel par sync_cron.php       *
	*     Version 1.2.0 et suivantes       *
	****************************************
	*/
	
	if (!isset($babInstallPath)) exit("Le programme ne peut pas tre excut directement : il doit tre appel par sync_cron.php !");
	
	include($babInstallPath."utilit/defines.php");
	include($babInstallPath."utilit/dbutil.php");
	global $babDB;
	$babDB = new babDatabase();
	global $babAddonsPath;
	global $babLanguage;
	global $babSkin;
	global $babUploadPath;
	$link = $babDB->db_connect();
	$res = $babDB->db_query ("
	SELECT 
	`lang`, 
	`skin`, 
	`uploadpath` 
	FROM 
	`bab_sites` 
	WHERE 
	`name` = '".$babDB->db_escape_string($babSiteName)."'
	");
	list($babLanguage, $babSkin, $babUploadPath) = $babDB->db_fetch_row($res);
	
	include($babInstallPath."utilit/addonapi.php");
	include($babInstallPath."utilit/utilit.php");
	
	if (!isset($GLOBALS['babMkdirMode']))
	{
		$GLOBALS['babMkdirMode'] = 0770;
	}
	if (!isset($GLOBALS['babUmaskMode']))
	{
		$GLOBALS['babUmaskMode'] = 0;
	}
	global $babAddonFolder;
	$babAddonFolder = $babInstallPath."lang/addons/synchroad/";
	
	global $babAddonPhpPath;
	$babAddonPhpPath = $babInstallPath."addons/synchroad/"; 
	
	global $babAddonHtmlPath ;
	$babAddonHtmlPath = $babInstallPath."skins/ovidentia/templates/addons/synchroad/"; 

	require_once $GLOBALS['babAddonPhpPath']."sad_ini.php";
	require_once $GLOBALS['babAddonPhpPath']."sync.inc.php";
	require_once $GLOBALS['babAddonPhpPath']."functions.php";

	global $BAB_SESS_LOGGED;
	$BAB_SESS_LOGGED = false;

	$test = parameters_for_orpeo_connexion($babSiteName);
	if ($test[0] === "Error")
	{
		$message = date("Y-m-d H:i:s")." : Erreur !\r\nLe paramtrage de la connexion entre l'Active Directory d'ORPO et Ovidentia n'est pas ralis.";		
		mail_for_information($message);
		exit($message);
	}
	else
	{
		if ($test[0] === false)
		{
			$message = date("Y-m-d H:i:s")." : Erreur !\r\nPas de connexion  l'Active Directory d'ORPEO avant la vrification des dlgations.";		
			mail_for_information($message);
			exit($message);	
		}
		else
		{
			list($r, $ds, $etab, $domain, $suffix) = $test;
			if ($r === false || $ds === false)
			{
				$error_in_ad_reading = true;
				$message = date("Y-m-d H:i:s")." : Erreur !\r\nPerte de la connexion  l'Active Directory d'ORPEO avant la vrification des dlgations.\r\n";
				mail_for_information($message);
				exit($message);	
			}
			else
			{
				$arr = test_desynchronized_delegations($ds, $etab, $domain, $suffix);
				if (count($arr) > 0)
				{
					$message = delete_desynchronized_delegations($arr);
					if (!empty($message))
					{
						mail_for_information ($message);
						echo $message;
					}
				}
				$test = parameters_for_orpeo_connexion($babSiteName);
				if ($test[0] === false)
				{
					$message = date("Y-m-d H:i:s")." : Erreur !\r\nPas de connexion  l'Active Directory d'ORPEO avant l'importation des comptes.\r\n";
					mail_for_information($message);
					exit($message);
				}
				else
				{
					$error_in_ad_reading = actionImportAccountsForm($test);
					if ($error_in_ad_reading === false)
					{
						$test = parameters_for_orpeo_connexion($babSiteName);
						if ($test[0] === false)
						{
							$message = date("Y-m-d H:i:s")." : Erreur !\r\nPerte de la connexion  l'Active Directory d'ORPEO avant la suppression des comptes.\r\n";
							mail_for_information($message);
							exit($message);
						}
						else
						{
							$error_in_ad_reading = actionDeleteAccountsForm($test);
							if ($error_in_ad_reading === false)
							{
								$test = parameters_for_orpeo_connexion($babSiteName);
								if ($test[0] === false)
								{
									$message = date("Y-m-d H:i:s")." : Erreur !\r\nPerte de la connexion  l'Active Directory d'ORPEO avant l'affectation des comptes.\r\n";
									mail_for_information($message);
									exit($message);
								}
								else
								{
									list($error_in_ad_reading, $warning_in_ad_reading, $desync1_groups_table, $desync2_groups_table, $unsync_groups_table) = actionAttachAccountsForm($test);
								
									if ($error_in_ad_reading === true)
									{
										$message = date("Y-m-d H:i:s")." : Erreur !\r\nLa procdure d'affectation des comptes pose problme.\r\n";
										mail_for_information($message);
										exit($message);
									}
									else
									{
										if ($warning_in_ad_reading === true)
										{
											$message = date("Y-m-d H:i:s")." : Avertissement !\r\nLa procdure d'affectation des comptes pose problme.\r\n";
											if (count($desync1_groups_table) > 0)
											{
												$message .= "Les groupes d'Ovidentia suivants, prcdement lis  des groupes d'ORPO, n'ont plus de correspondant dans l'actuelle structure d'ORPO :\r\n";
												foreach ($desync1_groups_table as $desync1_group)
												{
													$message .=$desync1_group."\r\n";
												}
											}
											if (count($desync2_groups_table) > 0)
											{
												$message .= "Les groupes d'ORPO suivants, prcdement lis  des groupes d'Ovidentia, n'ont plus de correspondant dans l'actuelle structure d'Ovidentia :\r\n";
												foreach ($desync2_groups_table as $desync2_group)
												{
													$message .=$desync2_group."\r\n";
												}
											}
											if (count($unsync_groups_table) > 0)
											{
												$message .= "Les groupes suivants, nouvellement crs dans l'Active Directory d'ORPO, n'ont pas leurs correspondants dans Ovidentia :\r\n";
												foreach ($unsync_groups_table as $unsync_group)
												{
													$message .=$unsync_group."\r\n";
												}
											}
											mail_for_information($message);
											exit($message);
										}
										else
										{
											$message = date("Y-m-d H:i:s")." : Synchronisation des comptes avec l'Active Directory d'ORPEO ralise\r\n";
											exit($message);
										}
									}
								}
							}
							else
							{
								$message = date("Y-m-d H:i:s")." : Erreur !\r\nLa procdure de suppression des comptes pose problme.\r\n";
								mail_for_information($message);
								exit($message);
							}
						}
					}
					else
					{
						$message = date("Y-m-d H:i:s")." : Erreur !\r\nLa procdure d'importation des comptes pose problme.\r\n";
						mail_for_information($message);
						exit($message);
					}
				}
			}
		}
	}
?>
