<?php

function is_ipv4_address($address)
{
	$ip_elements = explode(".", $address);
	if (count($ip_elements) > 4)
	{
		return(false);
	}
	else
	{
		if (is_numeric($ip_elements[0]) && is_numeric($ip_elements[1]) && is_numeric($ip_elements[2]) && is_numeric($ip_elements[3]))
		{
			if (($ip_elements[0] <= 255) && ($ip_elements[1] <= 255) && ($ip_elements[2] <= 255) && ($ip_elements[0] < 255))
			{
				return(true);
			}
		}
		else
		{
			return(false);
		}
	}
}

function parameters_for_orpeo_connexion($babSiteName)
{
	global $babDB;
	$res = $babDB->db_query("
	SELECT 
	`host`, 
	`port` , 
	`dn`, 
	`password`, 
	`crypt`, 
	`etab`, 
	`domaine`, 
	`suffixe` 
	FROM 
	`sad_params`, 
	`bab_sites` 
	WHERE 
	`id_site` = `bab_sites`.`id` 
	AND 
	`name` = '".$babDB->db_escape_string($babSiteName)."'
	");
	if ($babDB->db_num_rows($res) > 0)
	{
		list ($host, $port, $dn, $password, $crypt, $etab, $domaine, $suffixe)  = $babDB->db_fetch_row($res);
		// Dcryptage du mot de passe
		$password = ovi_decrypt($password, $crypt);
		$ds = @ldap_connect($host, $port);
		$r = @ldap_bind($ds, $dn, $password);
	}
	else
	{
		$r = "Error";
		$ds = false;
		$etab = false;
		$domaine = false;
		$suffixe = false;
	}
	return (array($r, $ds, $etab, $domaine, $suffixe));
}

function ovi_crypt($password)
{
	$cipher = "blowfish";
	$mode = "nofb";
	$key_size = mcrypt_module_get_algo_key_size($cipher);
	$iv_size = mcrypt_get_iv_size($cipher, $mode);
	$key = substr("elipse informatique really the best compagny in the world for ever", 0, $key_size);
	$iv = substr("orpeo is a great software", 0, $iv_size);
	$crypted_elements = array($key, $iv);
	$crypted_elements = serialize($crypted_elements);
	$password = mcrypt_encrypt($cipher, $key, $password, $mode, $iv);
	return array($password, $crypted_elements);
}

function ovi_decrypt($password, $crypt)
{
	$cipher = "blowfish";
	$mode = "nofb";
	$crypt = unserialize($crypt);
	$key = $crypt[0];
	$iv = $crypt[1];
	$password = mcrypt_decrypt($cipher, $key, $password, $mode, $iv);
	return $password;
}

function delete_delegation($id)
{
	// Fonction construite d'aprs la fonction confirmDeleteDelegatGroup($id) extraite du noyau ovidentia (admin/delagat.php)
	global $babDB;

	$idsafe = $babDB->db_escape_string($id);
	
	include_once $GLOBALS['babInstallPath']."utilit/delincl.php";
	include_once $GLOBALS['babInstallPath']."utilit/calincl.php";
	$res = $babDB->db_query("select id from ".BAB_SECTIONS_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteSection($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_TOPICS_CATEGORIES_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteTopicCategory($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_FLOW_APPROVERS_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteApprobationSchema($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_FORUMS_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteForum($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_FAQCAT_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteFaq($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_FM_FOLDERS_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteFolder($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_LDAP_DIRECTORIES_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteLdapDirectory($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_DB_DIRECTORIES_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteDbDirectory($arr['id']);
	}

	$res = $babDB->db_query("select id from ".BAB_ORG_CHARTS_TBL." where id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteOrgChart($arr['id']);
	}

	$res = $babDB->db_query("select crt.id, ct.id as idcal from ".BAB_CAL_PUBLIC_TBL." crt left join ".BAB_CALENDAR_TBL." ct on ct.owner=crt.id and ct.type='".BAB_CAL_PUB_TYPE."' where crt.id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteCalendar($arr['idcal']);
		$babDB->db_query("delete from ".BAB_CAL_PUBLIC_TBL." where id='".$arr['id']."'");	
	}

	$res = $babDB->db_query("select crt.id, ct.id as idcal from ".BAB_CAL_RESOURCES_TBL." crt left join ".BAB_CALENDAR_TBL." ct on ct.owner=crt.id and ct.type='".BAB_CAL_RES_TYPE."' where crt.id_dgowner='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteCalendar($arr['idcal']);
		$babDB->db_query("delete from ".BAB_CAL_RESOURCES_TBL." where id='".$arr['id']."'");	
	}
	
	// Suppression complmentaire des entres des fichiers dans les tables bab_files et bab_files_tags
	$res = $babDB->db_query("SELECT `id` FROM ".BAB_FILES_TBL." WHERE `iIdDgOwner` = '".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		$babDB->db_query("DELETE FROM ".BAB_FILES_TAGS_TBL." WHERE `id_file` = '".$babDB->db_escape_string($arr['id'])."'");
		$babDB->db_query("DELETE FROM ".BAB_FILES_TBL." WHERE `id` = '".$babDB->db_escape_string($arr['id'])."'");	
	}
	
	// Suppression complmentaire de l'espace projet
	include_once $GLOBALS['babInstallPath']."utilit/tmIncl.php";
	$res = $babDB->db_query("SELECT id FROM ".BAB_TSKMGR_PROJECTS_SPACES_TBL." WHERE `idDelegation` ='".$idsafe."'");
	while($arr = $babDB->db_fetch_array($res))
	{
		bab_deleteProjectSpace($arr['id']);
	}
	
	$babDB->db_query("delete from ".BAB_DG_ADMIN_TBL." where id_dg='".$idsafe."'");
	$babDB->db_query("delete from ".BAB_DG_GROUPS_TBL." where id='".$idsafe."'");
	$babDB->db_query("delete from ".BAB_DG_ACL_GROUPS_TBL." where id_object='".$idsafe."'");
}

function remove_group_and_all_children($id_group)
{
	global $babDB;
	$sub_groups = bab_getGroups($id_group, true);
	if (count($sub_groups) > 0)
	{
		foreach ($sub_groups["id"] as $id_sub_group)
		{
			bab_removeGroup($id_sub_group);
		}
	}
	bab_removeGroup($id_group);
}

function create_directory($id_group, $group_name, $description, $id_dgowner)
{
	global $babDB;
	
	$name = $group_name;
	$res = $babDB->db_query(
	"UPDATE `bab_groups`
	SET
	`directory` = 'Y'
	WHERE
	`id` = '".$babDB->db_escape_string($id_group)."'");
	$res = $babDB->db_query(
	"SELECT `id`
	FROM `bab_db_directories`
	WHERE `id_group` = '".$babDB->db_escape_string($id_group)."'");
	if (!$res || $babDB->db_num_rows($res) == 0)
	{
		$name = $group_name;
		$res = $babDB->db_query(
		"INSERT INTO `bab_db_directories`(
		`name`,
		`description`,
		`id_group`,
		`id_dgowner`)
		VALUES (
		'".$babDB->db_escape_string($name)."',
		'".$babDB->db_escape_string($description)."',
		'".$babDB->db_escape_string($id_group)."',
		'".$babDB->db_escape_string($id_dgowner)."')");
		$id_directory = $babDB->db_insert_id($res); 
	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$id_directory = $temp["id"];
		$babDB->db_query("
		UPDATE `bab_db_directories`
		SET
		`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."',
		`name` = '".$babDB->db_escape_string($name)."',
		`description` = '".$babDB->db_escape_string($description)."'
		WHERE `id_group` = '".$babDB->db_escape_string($id_group)."'");
	}
	return $id_directory;
}

function set_right_on_directory($id_directory, $right, $id_group)
{
	global $babDB;
	switch ($right)
	{
		case "add":
			$table = "bab_dbdiradd_groups";
			break;
		case "bind":
			$table = "bab_dbdirbind_groups";
			break;
		case "del":
			$table = "bab_dbdirdel_groups";
			break;
		case "empty":
			$table = "bab_dbdirempty_groups";
			break;
		case "export":
			$table = "bab_dbdirexport_groups";
			break;
		case "import":
			$table = "bab_dbdirimport_groups";
			break;
		case "unbind":
			$table = "bab_dbdirunbind_groups";
			break;
		case "update":
			$table = "bab_dbdirupdate_groups";
			break;
		case "view":
			$table = "bab_dbdirview_groups";
			break;
		default:
			$table = "";
			break;
	}
	if (!empty($table))
	{
		$res = $babDB->db_query("SELECT `id` FROM `".$table ."` WHERE `id_object` = ".$id_directory." AND `id_group` = ".$id_group);
		if ($babDB->db_num_rows($res) == 0)
		{
			$res= $babDB->db_query("INSERT INTO `".$table."`(`id_object`, `id_group`) VALUES (".$id_directory.", ".$id_group.")");
		}
	}
}

function create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $filenotify)
{
	global $babDB;
	$substitution_pattern = array_keys($GLOBALS["babFileNameTranslation"]);
	for ($i = 0; $i < count($GLOBALS["babFileNameTranslation"]); $i++)
	{
		$search	= $substitution_pattern[$i];
		$replace = $GLOBALS["babFileNameTranslation"][$search];
		$name = str_replace($search, $replace, $folder); 
	}
	$res = $babDB->db_query("
	SELECT `id`
	FROM `bab_fm_folders`
	WHERE
		`folder` = '".$babDB->db_escape_string($folder)."'
		AND `id_dgowner` = ".$id_dgowner."
		AND `sRelativePath` = '".$babDB->db_escape_string($relative_path)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$res = $babDB->db_query("
		INSERT INTO `bab_fm_folders`
		(`folder`,
		`sRelativePath`,
		`manager`,
		`idsa`,
		`filenotify`,
		`active`,
		`version`,
		`id_dgowner`,
		`bhide`,
		`auto_approbation`,
		`baddtags`,
		`bcap_downloads`,
		`max_downloads`,
		`bdownload_history`,
		`manual_order`)
		VALUES
		('".$babDB->db_escape_string($folder)."',
		'".$babDB->db_escape_string($relative_path)."',
		0,
		'".$babDB->db_escape_string($idsa)."',
		'".$babDB->db_escape_string($filenotify)."',
		'Y',
		'Y',
		'".$babDB->db_escape_string($id_dgowner)."',
		'".$babDB->db_escape_string($bhide)."',
		'Y',
		'N',
		'N',
		0,
		'Y',
		0
		)
		");
		$id_folder = $babDB->db_insert_id($res);
	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$id_folder = $temp["id"];
	}
	$res = $babDB->db_query("SELECT 
	`uploadpath` 
	FROM 
	`bab_sites` 
	WHERE 
	`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'
	");
	$temp = $babDB->db_fetch_array($res);
	$uploadpath = $temp["uploadpath"];
	if (!file_exists($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner)) mkdir($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner);
	if (!file_exists($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$relative_path)) mkdir($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$reltive_path);
	if (!file_exists($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$relative_path.DIRECTORY_SEPARATOR.$name)) mkdir($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$relative_path.DIRECTORY_SEPARATOR.$name);
	return $id_folder;
}

function set_right_on_folder($id_folder, $right, $id_group)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch ($right)
	{
		case "upload":
			$table = "bab_fmupload_groups";
			break;
		case "download":
			$table = "bab_fmdownload_groups";
			break;
		case "update":
			$table = "bab_fmupdate_groups";
			break;
		case "manage":
			$table = "bab_fmmanagers_groups";
			break;
		case "notify":
			$table = "bab_fmnotify_groups";
			break;
		case "unzip":
			$table = "bab_fmunzip_groups";
			break;
		default:
			$table = "";
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res = $babDB->db_query("
		SELECT 
		`id` 
		FROM
		`".$table ."`
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_folder)."' 
		AND 
		`id_group` = '".$babDB->db_escape_string($id_group)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res= $babDB->db_query("
			INSERT 
			INTO 
			`".$table."`
			(
				`id_object`, 
				`id_group`
			) 
			VALUES 
			(
				'".$babDB->db_escape_string($id_folder)."',
				'".$babDB->db_escape_string($id_group)."'
			)
			");
		}
	}
}

function transfer_right_on_folder($id_folder, $right, $id_old_group, $id_new_group)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch ($right)
	{
		case "upload":
			$table = "bab_fmupload_groups";
			break;
		case "download":
			$table = "bab_fmdownload_groups";
			break;
		case "update":
			$table = "bab_fmupdate_groups";
			break;
		case "manage":
			$table = "bab_fmmanagers_groups";
			break;
		case "notify":
			$table = "bab_fmnotify_groups";
			break;
		default:
			$table = "";
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res = $babDB->db_query("
		SELECT 
		`id` 
		FROM 
		`".$table ."` 
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_folder)."'
		AND 
		`id_group` = '".$babDB->db_escape_string($id_old_group)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res= $babDB->db_query("
			INSERT 
			INTO 
			`".$table."`
			(
				`id_object`, 
				`id_group`
			) 
			VALUES 
			(
				'".$babDB->db_escape_string($id_folder)."',
				'".$babDB->db_escape_string($id_new_group)."'
			)
			");
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_record = $temp["id"];
			$res = $babDB->db_query("
			UPDATE 
			`".$table."` 
			SET 
			`id_group` = '".$babDB->db_escape_string($id_new_group)."' 
			WHERE 
			`id` = '".$babDB->db_escape_string($id_record)."'
			");	
		}
	}
}

function set_def_right_on_topics_category($id_topcat, $right, $id_group)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch ($right)
	{
		case "comment":
			$table = "bab_def_topcatcom_groups";
			break;
		case "manage":
			$table = "bab_def_topcatman_groups";
			break;
		case "modify":
			$table = "bab_def_topcatmod_groups";
			break;
		case "submit":
			$table = "bab_def_topcatsub_groups";
			break;
		case "view":
			$table = "bab_def_topcatview_groups";
			break;
		default:
			$table = "";
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res = $babDB->db_query("SELECT 
		`id` 
		FROM 
		`".$table ."` 
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_topcat)."' 
		AND 
		`id_group` = '".$babDB->db_escape_string($id_group)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res= $babDB->db_query("
			INSERT 
			INTO 
			`".$table."`
			(
				`id_object`, 
				`id_group`
			) 
			VALUES 
			(
				'".$babDB->db_escape_string($id_topcat)."', 
				'".$babDB->db_escape_string($id_group)."'
			)
			");
		}
	}
}

function unset_def_right_on_topics_category($id_topcat,$right)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch ($right)
	{
		case "comment":
			$table = "bab_def_topcatcom_groups";
			break;
		case "manage":
			$table = "bab_def_topcatman_groups";
			break;
		case "modify":
			$table = "bab_def_topcatmod_groups";
			break;
		case "submit":
			$table = "bab_def_topcatsub_groups";
			break;
		case "view":
			$table = "bab_def_topcatview_groups";
			break;
		default:
			$table = "";
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res= $babDB->db_query("
		DELETE
		FROM 
		`".$table."` 
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_topcat)."'
		");
	}
}				

function set_right_on_topic($id_topic, $right, $id_group)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch($right)
	{
		case "view":
			$table = "bab_topicsview_groups";
			break;
		case "submit":
			$table = "bab_topicssub_groups";
			break;
		case "comment":
			$table = "bab_topicscom_groups";
			break;
		case "modify":
			$table = "bab_topicsmod_groups";
			break;				
		case "manage":
			$table = "bab_topicsman_groups";
			break;
		default:
			$table = "";
			break;
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res = $babDB->db_query("SELECT 
		`id` 
		FROM 
		`".$table."` 
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_topic)."'
		AND
		`id_group` = '".$babDB->db_escape_string($id_group)."'
		");
		if (mysql_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT 
			INTO 
			`".$table."` 
			(
				`id_object`, 
				`id_group`
			) 
			VALUES 
			(
				'".$babDB->db_escape_string($id_topic)."', 
				'".$babDB->db_escape_string($id_group)."'
			)
			");
		}
	}
}

function create_forum($name, $description, $id_dgowner, $moderation, $notification, $active)
{
	global $babBody;
	global $babDB;
	
	$managerid = $GLOBALS["BAB_SESS_USERID"];
	
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_forums` 
	WHERE 
	`name` = '".$babDB->db_escape_string($name)."'
	");
	if( $babDB->db_num_rows($res) == 0)
	{
		$res = $babDB->db_query("
		SELECT 
		MAX(`ordering`) 
		FROM `bab_forums`
		");
		if( $res )
		{
			$arr = $babDB->db_fetch_array($res);
			$max = $arr[0] + 1;
		}
		else
		{
			$max = 0;
		}
		$nbmsgdisplay = 20;
		$bdisplayemailaddress = "N";
		$bdisplayauhtordetails = "N";
		$bflatview = "Y";
		$bupdatemoderator = "Y";
		$bupdateauthor = "N";
		
		$res = $babDB->db_query("
		INSERT INTO `bab_forums` (
		`name`,
		`description`,
		`display`,
		`moderation`,
		`notification`,
		`active`,
		`ordering`,
		`id_dgowner`,
		`bdisplayemailaddress`,
		`bdisplayauhtordetails`,
		`bflatview`,
		`bupdatemoderator`,
		`bupdateauthor`
		)
		VALUES(
		'" . $babDB->db_escape_string($name). "',
		'" . $babDB->db_escape_string($description). "', 
		'" . $babDB->db_escape_string($nbmsgdisplay). "', 
		'" . $babDB->db_escape_string($moderation). "', 
		'" . $babDB->db_escape_string($notification). "', 
		'" . $babDB->db_escape_string($active). "', 
		'" . $babDB->db_escape_string($max). "', 
		'" . $babDB->db_escape_string($id_dgowner). "',
		'" . $babDB->db_escape_string($bdisplayemailaddress). "',
		'" . $babDB->db_escape_string($bdisplayauhtordetails). "',
		'" . $babDB->db_escape_string($bflatview). "',
		'" . $babDB->db_escape_string($bupdatemoderator). "',
		'" . $babDB->db_escape_string($bupdateauthor). "'
		)
		");
		
		$id = $babDB->db_insert_id($res);
		
		return $id;
	}
	else
	{
		return NULL;
	}
}

function set_right_on_forum($id_forum, $right, $id_group)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch ($right)
	{
		case "files":
			$table = "bab_forumsfiles_groups";
			break;
		case "manage":
			$table = "bab_forumsman_groups";
			break;
		case "notify":
			$table = "bab_forumsnotify_groups";
			break;
		case "post":
			$table = "bab_forumspost_groups";
			break;
		case "reply":
			$table = "bab_forumsreply_groups";
			break;
		case "view":
			$table = "bab_forumsview_groups";
			break;
		default:
			$table = "";
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res = $babDB->db_query("
		SELECT 
		`id` 
		FROM 
		`".$table ."` 
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_forum)."' 
		AND 
		`id_group` = '".$babDB->db_escape_string($id_group)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res= $babDB->db_query("
			INSERT 
			INTO 
			`".$table."`
			(
				`id_object`,
				`id_group`
			)
			VALUES
			(
				'".$babDB->db_escape_string($id_forum)."', 
				'".$babDB->db_escape_string($id_group)."'
			)
			");
		}
	}
}
  
function set_right_on_public_calendar($id_calendar, $right, $id_group)
{
	global $babDB;
	require_once($GLOBALS['babInstallPath']."utilit/upgradeincl.php");
	switch ($right)
	{
		case "groups":
			$table = "bab_cal_pub_grp_groups";
			break;
		case "manage":
			$table = "bab_cal_pub_man_groups";
			break;
		case "notify":
			$table = "bab_cal_pub_not_groups";
			break;
		case "view":
			$table = "bab_cal_pub_view_groups";
			break;
		default:
			$table = "";
	}
	if (($table != "") && (bab_isTable($table)))
	{
		$res = $babDB->db_query("SELECT 
		`id` 
		FROM 
		`".$table ."` 
		WHERE 
		`id_object` = '".$babDB->db_escape_string($id_calendar)."' 
		AND 
		`id_group` = '".$babDB->db_escape_string($id_group)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res= $babDB->db_query("
			INSERT 
			INTO `".$table."`
			(
				`id_object`, 
				`id_group`
			)
			VALUES
			(
				'".$babDB->db_escape_string($id_calendar)."', 
				'".$babDB->db_escape_string($id_group)."'
			)
			");
		}
	}
}

function test_desynchronized_delegations($ds, $etab, $domain, $suffix)
{
	global $babDB;
	
	$arr = array();

	// Recherche des dlgations bases sur les groupes inter-classes existent alors que les groupes interclasses de l'Active Directory d'OORO ont t supprims
	$base_dn = "OU=groupe, OU=".$etab.", DC=".$domain.", DC=".$suffix;
	$res = $babDB->db_query("
	SELECT 
	`group_name`, 
	`id_deleg` 
	FROM 
	`sad_created_group_deleg`, 
	`bab_sites` 
	WHERE 
	`bab_sites`.`id` = `id_site` 
	AND `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'
	");
	while (list($group_name, $id_deleg) = $babDB->db_fetch_row($res))
	{
		$filter = "(cn=gp_eleve".$group_name.")";
		$sr = ldap_search($ds, $base_dn, $filter);
		if (ldap_count_entries($ds, $sr) == 0)
		{
			$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
		}
	}

	// Recherche des dlgations bases sur des groupes issus des classes alors que leur correspondant dans l'Active Directory d'ORPO ont t supprims
	$res = $babDB->db_query("SELECT `bab_dg_groups`.`name` AS `group_name`, `e`, `c`, `n`, `s`,`i`, `id_deleg` FROM `bab_dg_groups`, `sad_created_class_deleg`, `bab_sites` WHERE `bab_dg_groups`.`id` = `id_deleg` AND `id_site` = `bab_sites`.`id` AND `bab_sites`.`name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
	while (list($group_name, $ens, $cycle, $level, $speciality, $iclass, $id_deleg) = $babDB->db_fetch_row($res))
	{
		if (!is_null($ens) && is_null($cycle) && is_null($level) && is_null($speciality) && is_null($iclass))
		{
			// Dlgation base sur l'enseignement
			$base_dn = "OU=".$ens.", OU=affecte, OU=eleve, OU=".$etab.", DC=".$domain.", DC=".$suffix;
			$filter = "(OU=*)";
			$sr = @ldap_search($ds, $base_dn, $filter);
			if (!$sr)
			{
				$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
			}
		}
		else
		{
			if (!is_null($ens) && !is_null($cycle) && is_null($level) && is_null($speciality) && is_null($iclass))
			{
				// Dlgation base sur le cycle
				$base_dn = "OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$etab.", DC=".$domain.", DC=".$suffix;
				$filter = "(OU=*)";
				$sr = @ldap_search($ds, $base_dn, $filter);
				if (!$sr)
				{
					$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
				}
			}
			else
			{
				if (!is_null($ens) && !is_null($cycle) && !is_null($level) && is_null($speciality) && is_null($iclass))
				{
					// Dlgation base sur le niveau
					$base_dn = "OU=".$level.$cycle.", OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$etab.", DC=".$domain.", DC=".$suffix;
					$filter = "(OU=*)";
					$sr = @ldap_search($ds, $base_dn, $filter);
					if (!$sr)
					{
						$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
					}
				}
				else
				{
					if (!is_null($ens) && !is_null($cycle) && is_null($level) && !is_null($speciality) && is_null($iclass))
					{
						// Dlgation base sur la spcialit (indpendante du niveau)
						$existing_speciality_arr = array();
						$base_dn = "OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$etab.", DC=".$domain.", DC=".$suffix;
						$filter = "(OU=*)";
						$sr = @ldap_search($ds, $base_dn, $filter);
						if ($sr === false)
						{
							$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
						}
						else
						{
							if (ldap_count_entries($ds, $sr) > 0)
							{
								$entry = ldap_first_entry($ds, $sr);
								while ($entry)
								{
									$dn = ldap_get_dn($ds, $entry);
									$temp = ldap_explode_dn($dn, 1);
									if (count($temp) == 10)
									{
										$s = explode($temp[1], $temp[0]);
										$s = $s[1];
										// $l = explode($temp[2], $temp[1]);
										// $l = $l[0]; Le niveau n'est pas considr au moment du choix de la spcialit
										// $l = null;
										$c = $temp[2];
										$e = $temp[3];
										$existing_speciality[] = $s;
									}
									$entry = ldap_next_entry($ds, $entry);
								}
								if (!in_array($speciality, $existing_speciality))
								{
									$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
								}
							}
							else
							{
								$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
							}
						}
					}
					else
					{
						if (!is_null($ens) && !is_null($cycle) && !is_null($level) && !is_null($speciality) && !is_null($iclass))
						{
							// Dlgation base sur la classe
							$base_dn = "OU=".$level.$cycle.$speciality.$iclass.", OU=".$level.$cycle.$speciality.", OU=".$level.$cycle.", OU=".$cycle.", OU=".$ens.", OU=affecte, OU=eleve, OU=".$etab.", DC=".$domain.", DC=".$suffix;
							$filter = "(OU=*)";
							$sr = @ldap_search($ds, $base_dn, $filter);
							if ($sr === false)
							{
								$arr[] = array("group_name" => $group_name, "id_deleg" => $id_deleg);
							}
						}
					}
				}
			}
		}
	}
	return($arr);
}

function delete_desynchronized_delegations($arr)
{
	global $babDB;
	$message = "";	
	foreach ($arr as $value)
	{
		$group_name = $value["group_name"];
		$id_deleg = $value["id_deleg"];
		
		$res = $babDB->db_query("
		SELECT 
		`id_group` 
		FROM 
		`bab_dg_groups` 
		WHERE 
		`id` = '".$babDB->db_escape_string($id_deleg)."'
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$temp = $babDB->db_fetch_array($res);
			$id_group = $temp["id_group"];
			remove_group_and_all_children($id_group);
		}
		delete_delegation($id_deleg);
		$res = $babDB->db_query("
		DELETE 
		FROM 
		`sad_created_class_deleg_temp` 
		WHERE 
		`id_deleg` = '".$babDB->db_escape_string($id_deleg)."'
		");
		$res = $babDB->db_query("
		DELETE 
		FROM 
		`sad_created_class_deleg` 
		WHERE 
		`id_deleg` = '".$babDB->db_escape_string($id_deleg)."'
		");
		$res = $babDB->db_query("
		DELETE 
		FROM 
		`sad_created_group_deleg` 
		WHERE 
		`id_deleg` = '".$babDB->db_escape_string($id_deleg)."'
		");
		$res = $babDB->db_query("
		DELETE 
		FROM 
		`sad_groups_tree` 
		WHERE 
		`id_deleg` = '".$babDB->db_escape_string($id_deleg)."'
		");
		$message .= date("Y-m-d H:i:s")." : La dlgation ".$group_name." a t supprime ; elle ne correspondait plus  des lments de l'Active Directory d'ORPO\r\n";
	}
	unset($value);
	return ($message);
}

function FindGroupIdFromName($group_name, $id_parent)
{
	global $babDB;
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	(UPPER(`name`) = UPPER('".$babDB->db_escape_string($group_name)."')) 
	AND 
	(`id_parent` = '".$babDB->db_escape_string($id_parent)."')
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		return(false);
	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		return($temp["id"]);
	}
}

?>