<?php
require_once 'base.php';

require_once $GLOBALS['babAddonPhpPath']."sync.inc.php";

function displayAttachAccountsForm()
{
	global $babBody;
	class displayAttachAccountsFormClass 
	{
		function displayAttachAccountsFormClass()
		{
			$this->home_message = bab_translate("Caution : you will attach the users (students or teachers) to the delegated groups in Ovidentia!", $GLOBALS['babAddonFolder']);
			$this->confirm_message = bab_translate("Do you want to continue?", $GLOBALS['babAddonFolder']);
			$this->yes = bab_translate("Yes", $GLOBALS['babAddonFolder']);
			$this->no = bab_translate("No", $GLOBALS['babAddonFolder']);
		}		
	}
	$obj= new displayAttachAccountsFormClass();
	$babBody->babecho( bab_printTemplate($obj, $GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_home"));
}

function displayDeleteAccountsForm()
{
	global $babBody;
	class displayDeleteAccountsFormClass 
	{
		function displayDeleteAccountsFormClass()
		{
			$this->home_message = bab_translate("Caution : you will delete the accounts of former users (students or teachers) in Ovidentia!", $GLOBALS['babAddonFolder']);
			$this->confirm_message = bab_translate("Do you want to continue?", $GLOBALS['babAddonFolder']);
			$this->yes = bab_translate("Yes", $GLOBALS['babAddonFolder']);
			$this->no = bab_translate("No", $GLOBALS['babAddonFolder']);
		}
		
	}
	$obj= new displayDeleteAccountsFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_home"));
}

function displayImportAccountsForm()
{
	global $babBody;
	class displayImportAccountsFormClass 
	{
		function displayImportAccountsFormClass()
		{
			$this->home_message = bab_translate("Caution : you will import the accounts of new users (students or teachers) in Ovidentia!", $GLOBALS['babAddonFolder']);
			$this->confirm_message = bab_translate("Do you want to continue?", $GLOBALS['babAddonFolder']);
			$this->yes = bab_translate("Yes", $GLOBALS['babAddonFolder']);
			$this->no = bab_translate("No", $GLOBALS['babAddonFolder']);
		}
		
	}
	$obj= new displayImportAccountsFormClass();
	$babBody->babecho( bab_printTemplate($obj,$GLOBALS["babAddonHtmlPath"]."sync_accounts.html", "sync_home"));
}

$idx = bab_rp('idx', 'import');

switch($idx)
{
	case 'attach':
		if (bab_isUserAdministrator())
		{
			$babBody->addItemMenu("import", bab_translate("Importation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=import");
			$babBody->addItemMenu("delete", bab_translate("Delete", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=delete");
			$babBody->addItemMenu("attach", bab_translate("Attachment", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=attach");
			
			$babBody->title = bab_translate("Attachment of the users to the groups", $GLOBALS['babAddonFolder']);
			require_once $GLOBALS['babAddonPhpPath']."functions.php";
			list ($r, $ds, $etab, $domain, $suffix)= parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($r === false)
			{
				$babBody->addError(bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS['babAddonFolder']));
			}
			else
			{
				$confirm = bab_rp("confirm", "");
				if ($confirm == "")
				{
					displayAttachAccountsForm();
				}
				else
				{
					if ($confirm == "yes")
					{
						actionAttachAccountsForm(array($r, $ds, $etab, $domain, $suffix));
					}
				}				
			}
		}
		break;
		case 'delete':
		if (bab_isUserAdministrator())
		{
			$babBody->addItemMenu("import", bab_translate("Importation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=import");
			
			$babBody->addItemMenu("delete", bab_translate("Delete", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=delete");
			$babBody->title = bab_translate("Delete former users accounts", $GLOBALS['babAddonFolder']);
			require_once $GLOBALS['babAddonPhpPath']."functions.php";
			list ($r, $ds, $etab, $domain, $suffix)= parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($r === false)
			{
				$babBody->addError(bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS['babAddonFolder']));
			}
			else
			{
				$confirm = bab_rp("confirm", "");
				if ($confirm == "")
				{
					displayDeleteAccountsForm();
				}
				else
				{
					if ($confirm == "yes")
					{
						actionDeleteAccountsForm(array($r, $ds, $etab, $domain, $suffix));
					}
				}				
			}
			$babBody->addItemMenu("attach", bab_translate("Attachment", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=attach");
		}
		break;
	case 'import':
	default:
		if (bab_isUserAdministrator())
		{
			$babBody->addItemMenu("import", bab_translate("Importation", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=import");
			$babBody->title = bab_translate("Importation of the new users accounts", $GLOBALS['babAddonFolder']);
			require_once $GLOBALS['babAddonPhpPath']."functions.php";
			list ($r, $ds, $etab, $domain, $suffix)= parameters_for_orpeo_connexion($GLOBALS["babSiteName"]);
			if ($r === false)
			{
				$babBody->addError(bab_translate("Error : No connexion to the ORPEO Active Directory!", $GLOBALS['babAddonFolder']));
			}
			else
			{
				$confirm = bab_rp("confirm", "");
				if ($confirm == "")
				{
					displayImportAccountsForm();
				}
				else
				{
					if ($confirm == "yes")
					{
						actionImportAccountsForm(array($r, $ds, $etab, $domain, $suffix));
					}
				}				
			}
			$babBody->addItemMenu("delete", bab_translate("Delete", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=delete");
			$babBody->addItemMenu("attach", bab_translate("Attachment", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."sync_accounts&idx=attach");
		}
		break;
}

$babBody->setCurrentItemMenu($idx);

?>